﻿/*
 Skype Plugin for Regnessem
 Copyright (c) 2004 Sapphire All rights Reserved.
*/

module Skype;

private {
  import win32.ansi.windows;
  import nsmsgs.consts, nsmsgs.types;
  import std.string, std.utf;
}

// Initialize関数で渡されるPNsmPluginInitInfoを保持する変数
TNsmPluginInitInfo g_InitInfo;
HINSTANCE g_hInstance;

const char[] MODULENAME = "Skype";

extern (C) {
  void gc_init();
  void gc_term();
  void _minit();
  void _moduleCtor();
  void _moduleUnitTests();
}

private {
  const char[][] PluginInfo = [
    NSM_API_VERSION,
    "AddIn/"~MODULENAME,
    "Skype",
    "Skype",
    "Sapphire",
    "Copyright (c) 2004 Sapphire",
    "0.0.1",
  ];
}

extern (Windows)
BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
  switch (ulReason) {
  case DLL_PROCESS_ATTACH:
    gc_init();          // init GC
		_minit();           // init module list
		_moduleCtor();      // run  module constructor
		_moduleUnitTests(); // run  unit test
		break;
	case DLL_PROCESS_DETACH:
		gc_term();
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		// multi-thread is not supported
		return FALSE;
	}
  
  g_hInstance = hInstance;
  
	return TRUE;
}

extern (Windows)
int GetPluginInfo(int nInfoNo, LPTSTR lpBuffer, int nSize)
{
	if (nInfoNo < 0 || nInfoNo > PluginInfo.length) {
		return 0;
	} else {
		lstrcpyn(lpBuffer, toStringz(PluginInfo[nInfoNo]), nSize);
		return lstrlen(lpBuffer);
	}
}

extern (Windows)
int Initialize(PNsmPluginInitInfo lpInitInfo)
{
  g_InitInfo = *lpInitInfo;
  createAllServices();

  return 0;
}

extern (Windows)
int Terminate()
{
	return 0;
}

extern(Windows)
int Common_ShowOptionDialog(WPARAM wParam, LPARAM lParam) {
	return 0;
}

extern(Windows)
int Call_Member(WPARAM wParam, LPARAM lParam) {
	HNsmConnection    hConnection = cast(HNsmConnection)    wParam;
	PNsmUIServiceInfo lpUISvcInfo = cast(PNsmUIServiceInfo) lParam;
	
	char[] skype_name;
	skype_name.length=128;
	
	int len = GetPrivateProfileString(
								toStringz("user"),
								lpUISvcInfo.lpAccount,
								"",
								skype_name,
								128,
								toStringz(".\\Plugins\\Skype\\user.dat")
						);
	
	skype_name = skype_name[0..len];

	switch (lpUISvcInfo.nInfoKey) {
		case NMUI_GETCAPTION:
			lstrcpynW(
				cast(LPCWSTR)lpUISvcInfo.lpInfo.lpBuffer,
				cast(LPCWSTR)"電話をかける",
				lpUISvcInfo.lpInfo.nBufferSize
			);
			break;
		case NMUI_ONCLICK:
			OutputDebugString(toStringz(skype_name));
			if(skype_name.length>0) {
				ShellExecute(
						NULL,
						NULL,
						toStringz("callto:"~skype_name),
						NULL,
						NULL,
						SW_SHOWNORMAL
				);
			} else {
				MessageBox(NULL, "No entry.", "", MB_OK);
			}
			break;
		default:
			return 0;
	}
	return 1;
}

extern(Windows)
void createAllServices() {
	char buf[];
	
	// 共通サービスの作成
	buf = format(NMS_COMMON_SHOWOPTIONDIALOG, "AddIn/"~MODULENAME);
	g_InitInfo.CreateService(toStringz(buf), &Common_ShowOptionDialog);
	
	buf = format("AddIn/"~MODULENAME~"/UIService/Member/0_Call");
	g_InitInfo.CreateService(toStringz(buf), &Call_Member);
}
